#include<bits/stdc++.h>
using namespace std;
int mas[100001];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, pr=1, ans=n;
    cin>>n;
    for(int i=2; pr*i+1<=n; i++)
    {
        pr*=i;
        for(int j=1; j<=n; j+=pr)
        {
            if(mas[j]==i-1 || (i==2 && mas[j]==0))
            {
                mas[j]=i;
                ans=j;
            }
        }
    }
    cout<<ans;
    return 0;
}
